package de.renew.netcomponents;

import CH.ifa.draw.util.Command;

import de.renew.plugin.IPlugin;


/**
 * The command that is executed for showing the netcomponents.
 *
 * @author Lawrence Cabac
 */
public class ShowNetComponentsToolCommand extends Command {
    IPlugin _plugin;
    private String _toolsDirPropertyName;

    public ShowNetComponentsToolCommand(IPlugin plugin) {
        super("default (toggle on/off)");
        _plugin = plugin;
    }

    public ShowNetComponentsToolCommand(IPlugin plugin, String menutext,
                                        String toolsDir) {
        super(menutext);
        _plugin = plugin;
        _toolsDirPropertyName = toolsDir;


        //        System.out.println("=============================================");
        //        System.out.println("The set tools dir is: " + toolsDir);
        //        System.out.println("=============================================");
    }

    /**
     * Shows the Net Components Tools Palette
     * @see Command#execute()
     */
    public void execute() {
        ComponentsToolPlugin ctp = (ComponentsToolPlugin) _plugin;
        ctp.createPalette(_toolsDirPropertyName);
    }
}