package de.renew.remote;

import de.renew.application.SimulationEnvironment;

import de.renew.net.NetElementID;
import de.renew.net.Place;

import java.rmi.RemoteException;


/**
 * This class implements the <code>PlaceAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * PlaceAccessorImpl.java
 * Created: Fri Jul 14  2000
 * @author Michael Duvigneau
 */
public class PlaceAccessorImpl extends ObjectAccessorImpl
        implements PlaceAccessor {

    /**
     * Creates a new place accessor for the given place.
     *
     * @param place the place to access
     * @exception java.rmi.RemoteException if an RMI failure occured.
     */
    public PlaceAccessorImpl(Place place, SimulationEnvironment env)
            throws RemoteException {
        super(place, env);
    }

    /* This method is specified by the PlaceAccessor interface. */
    public NetElementID getID() throws RemoteException {
        return ((Place) object).getID();
    }

    /**
     * Returns the place, if the caller knows that
     * this is the local representation. This is required for setting breakpoints.
     * @return The place.
     */
    public Place getPlace() {
        return (Place) object;
    }
}