package de.renew.remote;

import de.renew.application.SimulationEnvironment;

import de.renew.net.NetElementID;
import de.renew.net.Transition;

import java.rmi.RemoteException;


/**
 * This class implements the <code>TransitionAccessor</code> interface
 * and nothing more.
 * <p>
 * </p>
 * TransitionAccessorImpl.java
 * Created: Sun Jul 16  2000
 * @author Michael Duvigneau
 */
public class TransitionAccessorImpl extends ObjectAccessorImpl
        implements TransitionAccessor {

    /**
     * Creates a new transition accessor for the given transition.
     *
     * @param transition the transition to access
     * @exception java.rmi.RemoteException if an RMI failure occured.
     */
    public TransitionAccessorImpl(Transition transition,
                                  SimulationEnvironment env)
            throws RemoteException {
        super(transition, env);
    }

    /* This method is specified by the TransitionAccessor interface. */
    public NetElementID getID() throws RemoteException {
        return ((Transition) object).getID();
    }

    /**
     * Returns the transition, if the caller knows that
     * this is the local representation. This is required for setting breakpoints.
     * @return The transition.
     */
    public Transition getTransition() {
        return (Transition) object;
    }
}