package de.renew.shadow;

import java.util.Vector;


public class SyntaxException extends Exception {
    public final String[] detailed;
    public final int line;
    public final int column;
    public final Vector errorObjects;

    public SyntaxException(String msg, String[] detailed, int line, int column,
                           Throwable cause) {
        super(msg, cause);
        this.detailed = detailed;
        this.line = line;
        this.column = column;
        errorObjects = new Vector();
    }

    public SyntaxException(String msg, String[] detailed, int line, int column) {
        this(msg, detailed, line, column, null);
    }

    public SyntaxException(String msg, String[] detailed) {
        this(msg, detailed, 0, 0, null);
    }

    public SyntaxException(String msg, Throwable cause) {
        this(msg, null, 0, 0, cause);
    }

    public SyntaxException(String msg) {
        this(msg, null, 0, 0, null);
    }

    public SyntaxException addObject(Object graphicObject) {
        errorObjects.addElement(graphicObject);
        return this;
    }
}